/***********************************************************************
 	: ch3_String.c
			: .  
				:    , 
************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch3_String.h"

/* */

void dimiourgia(typos_seiras *seira)
{
 /*
 *	: 		
 *	: 		  
*/
	seira->mikos=0;
}

int mikos(typos_seiras seira)
{
 /*
 *	: 		  seira
 *	: 		      seira.
*/
	return seira.mikos;
}

char anaktisi(typos_seiras seira,int i)
{
 /*
 *	: 		  seira
 *	: 		  - .
*/
	if((0<=i)&&(i<=mikos(seira)))
		return seira.xaraktiras[i];
	else
		printf("  \n");
	return '\0';
}

void prosartisi(typos_seiras *seira, char xar)
{
 /*
 *	: 		  seira
 *	: 		   xar     
 *				 seira.
*/
	if (mikos(*seira)==MEG_MIKOS)
		printf("   \n");
	else
	{
		seira->mikos++;
		seira->xaraktiras[seira->mikos-1]=xar;
	}
}

void diagrafi(typos_seiras *seira)
{
 /*
 *	: 		  seira,   seira
 *	: 		   	 
*/
	int i;
	if (mikos(*seira)==0)
		printf(" \n");
	else
	{
		for (i=0;i<=(seira->mikos-2);i++)
			seira->xaraktiras[i] = seira->xaraktiras[i+1];
		seira->mikos--;
	}
}

void antigrafi_seiras(typos_seiras arxiki, int thesi, int n, typos_seiras *neaseira)
{
 /*
 *:   arxiki, 1<=thesi<=n, 1<=n<=MEG_MIKOS.
 *:   neaseira    n   arxiki  
 *		  thesi
*/
	int i, teleytaios;

	/*      */
	teleytaios = thesi+n-1;
	if (teleytaios>MEG_MIKOS)
		printf("     .\n");
	else
	{
		dimiourgia(neaseira);
		/*  n    thesi  seira  neaseira*/
		for (i=1;i<=n;i++)
			prosartisi(neaseira,anaktisi(arxiki,thesi+i-1));
	}
}

void synenosi_seiras(typos_seiras seira1, typos_seiras seira2, typos_seiras *neaseira)
{
 /*
 *:    seira1  seira2.      
 *		siera1  seira2 <= MEG_MIKOS.
 *:         seira1  seira2.
*/
	int mks1,mks2;

	mks1 = mikos(seira1);
	mks2 = mikos(seira2);

	if (mks1+mks2>MEG_MIKOS)
		printf("        \n.");
	else
	{
		dimiourgia(neaseira);
		/*  seira1  neaseira*/
		antigrafi_seiras(seira1,0,mks1,neaseira);
		/*  seira2  neaseira*/
		antigrafi_seiras(seira2,mks1-1,mks2,neaseira);
 	}
}

int anazitisi_seiras(typos_seiras sxima, typos_seiras keimeno)
{
 /*
 *:    sxima  keimeno.
 *:         sxima  keimeno,
 *		  ,     -2.    sxima 
 *		    -1
*/
	int s,k,thesi,mkss,mksk;

	mkss = mikos(sxima);
	mksk = mikos(keimeno);

	if (mkss == 0)
		return -1;
	else if (mkss>mksk)
		return -2;
	else
	{
		thesi = 0;	/*   sxima  keimeno*/
		s=0;		/*    sxima*/
		k=0;		/*    keimeno*/

		while ((s<mkss)&&(k<mksk))
		{
			if ( anaktisi(sxima,s) == anaktisi(keimeno,k) )
			/*  */
			{
				s++;
				k++;
			}
			else
			/*   */
			{
				thesi++;
				k=thesi;
				s=0;
			}
		}
		/*  sxima   keimeno*/
		if (s>mkss-1)
			return thesi;
		else /*  */
			return -2;
	}
}

void eisagogi_seiras(typos_seiras seira1, typos_seiras *seira2, int thesi)
{
 /*
 *:    seira1  seira2.
 *:   seira1   seira2   thesi.
*/
	typos_seiras proti,teleytaia /*      siera2.*/;
	
	if ( (0<=thesi) && (thesi<mikos(*seira2)) )
	{
		antigrafi_seiras(*seira2,0,thesi,&proti);
		antigrafi_seiras(*seira2,thesi,mikos(*seira2)-thesi,&teleytaia);

		synenosi_seiras(proti,seira1,&proti);
		synenosi_seiras(proti,teleytaia,seira2);

	}
	else
		printf("      thesi\n.");
}

void diagrafi_seiras(typos_seiras *seira, int thesi, int mks)
{
 /*
 *:   seira
 *: mks    seira      thesi thesi.
*/

	typos_seiras proti,teleytaia /*      siera.*/;
	
	if ( (0<=thesi) && (mks<=mikos(*seira)-thesi) )
	{
		antigrafi_seiras(*seira,0,thesi,&proti);
		thesi+= mks;
		antigrafi_seiras(*seira,thesi,mikos(*seira)-thesi,&teleytaia);

		synenosi_seiras(proti,teleytaia,seira);

	}
	else
		printf("      thesi\n.");
}

void antikatastasi_seiras(typos_seiras seira1, typos_seiras seira2, typos_seiras *seira)
{
 /*
 *:    seira1  seira2.
 *:    seira1 (    -  -)
 *		 seira    seira2. 
*/
	int thesi;
	int mks;

	thesi = anazitisi_seiras(seira1,*seira);

	if (thesi>0)
	{
		mks = mikos(seira1);
		diagrafi_seiras(seira,thesi,mks);
		eisagogi_seiras(seira2,seira,thesi);
	}
}

char sygrisi(typos_seiras seira1, typos_seiras seira2)
{
 /*
 *:    seira1  seira2.
 *:   seira1    seira2.E 
 *		'<'  seira1 < seira2,
 *		'='  seira1 = seira2,
 *		'>'  seira1 > seira2,
 *		            
 *		.            
 *		,     ''
*/
	int  i,ises;
	i=0;
	ises=1;

	while ( ises && (i<mikos(seira1)) && (i<mikos(seira2)) )
	{
		if ( anaktisi(seira1,i) == anaktisi(seira2,i) )
			i++;
		else
		{
			ises=0;
			if ( anaktisi(seira1,i) < anaktisi(seira2,i) )
				return '<';
			else 
				return '>';
		}
	}

	if (ises)
	{
		if ( mikos(seira1) == mikos(seira2) )
			return '=';
		else if ( mikos(seira1) < mikos(seira2) )
			return '<';
		else
			return '>';
	}
	return '-';
}

void diavase_seira(typos_seiras *seira)
{
 /*
 *: .
 *:           seira
*/
	char xar;

	dimiourgia(seira);
	xar = getchar();
	while ( xar != '\n' )
	{
		prosartisi(seira,xar);
		xar = getchar();
	}
}

void typose_seira(typos_seiras seira)
{
 /*
 *: .
 *:     seira   
*/
	int i,mks;
	mks = mikos(seira);
	for (i=0;i<=mks-1;i++)
		putchar(anaktisi(seira,i));
}

