/***************************************************************************************
 oo	: ch7_CLpointer.c
			: .  
				:      ,  
****************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch7_CLpointer.h"

void dimiourgia(typos_deikti *lista)
{
 /*	
 *	o: 		
 *	: 		o   
*/	
	*lista = NULL;
}

int keni(typos_deikti lista)
{
 /*	
 *	o: 		o 
 *	:		 1     , o 0
*/
	return ( lista == NULL );
}

void proxorise(typos_deikti *p)
{
 /*	
 *	o: 		  p     
 *	:		  p      
*/
	*p = (*p)->epomenos;
}

typos_stoixeiou periexomeno(typos_deikti p)
{
 /*	
 *	o: 		  p     
 *	:		        p
*/
	return (p->dedomena);
}

void eisagogi_meta(typos_deikti prodeiktis,typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		o 
 *	: 		     stoixeio   
 *				      prodeiktis
*/
	typos_deikti prosorinos; /*       */

	prosorinos = (typos_deikti)malloc(sizeof(typos_komvou));
	if ( prosorinos == NULL )
	{
		fprintf(stderr,"   \n");
		exit(-1);
	}
	prosorinos->dedomena = stoixeio;
	prosorinos->epomenos = prodeiktis->epomenos;
	prodeiktis->epomenos = prosorinos;
}

void eisagogi_arxi(typos_deikti *lista,typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		O  p     
 *	: 		     stoixeio   
 *				      p,  p       
*/
	typos_deikti prosorinos; /*       */

	prosorinos = (typos_deikti)malloc(sizeof(typos_komvou));
	if ( prosorinos == NULL )
	{
		fprintf(stderr,"   \n");
		exit(-1);
	}
	prosorinos->dedomena = stoixeio;
	prosorinos->epomenos = *lista;
	*lista = prosorinos;
}

void eisagogi(typos_deikti *lista,typos_stoixeiou stoixeio,typos_deikti prodeiktis)
{
 /*	
 *	o: 		 prodeiktis        NULL
 *	: 		  prodeiktis  NULL      
 *				stoixeio          
 *				     prodeiktis
*/
	if (keni(prodeiktis)) /*    */
		eisagogi_arxi(lista,stoixeio);
	else
		eisagogi_meta(prodeiktis,stoixeio);
}

void diagrafi_komvou(typos_deikti *lista, typos_deikti prodeiktis)
{
 /*	
 *	o: 		 prodeiktis        NULL
 *	: 		  prodeiktis  NULL      
 *				 ,          prodeiktis
*/
	typos_deikti prosorinos;

	if (keni(*lista))
		printf("   !\n");
	else
	{
		if (keni(prodeiktis))
			diagrafi(lista);
		else /*o   */
		{
			prosorinos = prodeiktis->epomenos;
			diagrafi(&prosorinos);
			prodeiktis->epomenos = prosorinos;
		}
	}
}

void diagrafi(typos_deikti *p)
{
 /*	
 *	o: 		 p     
 *	: 		      p.  p     
*/
	typos_deikti prosorinos;	/*     */
	prosorinos = *p;
	*p = prosorinos->epomenos;
	free(prosorinos);
	prosorinos = NULL;
}

void diadromi(typos_deikti lista)
{
 /*	
 *	o: 		o 
 *	: 		       
 *				    
*/
	typos_deikti trexon; /*   */

	trexon = lista;
	while(!keni(trexon))
	{
		/*      */
		proxorise(&trexon);
	}
}

void anazitisi_listas(typos_deikti lista,typos_stoixeiou stoixeio,
				typos_deikti *prodeiktis, int *vrethike)
{
 /*	
 *	o: 		        
 *	: 		   lista       
 *				     stoixeio (vrethike =1)    
 *				     (vrethike =0).  prodeiktis  
 *				       stoixeio     
 *				      stoixeio
*/
	typos_deikti trexon;
	int anazitisi;

	trexon = lista;
	*prodeiktis = NULL;
	*vrethike = 0;
	anazitisi=0;
	while ( (!(anazitisi)) && (!keni(trexon)))
	{
		if (periexomeno(trexon) >= stoixeio)
		{
			anazitisi = 1;
			*vrethike = (periexomeno(trexon) == stoixeio);
		}
		else
		{
			*prodeiktis = trexon;
			proxorise(&trexon);
		}
	}
}


