/**************************************************************************
 oo	: ch7_CHLpointer.c
			: .  
				:    ,    
***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch7_CHLpointer.h"

void chl_dimiourgia(typos_deikti *lista)
{
 /*	
 *	o: 		
 *	: 		o   
*/	
	*lista = (typos_deikti)malloc(sizeof(typos_komvou));
	(*lista)->epomenos = NULL;
}

int chl_keni(typos_deikti lista)
{
 /*	
 *	o: 		o 
 *	:		 1     , o 0
*/
	return ( lista->epomenos == NULL );
}

typos_stoixeiou chl_periexomeno(typos_deikti p)
{
 /*	
 *	o: 		  p     
 *	:		        p
*/
	return (p->dedomena);
}

void chl_eisagogi(typos_stoixeiou stoixeio,typos_deikti prodeiktis)
{
 /*	
 *	o: 		o 
 *	: 		     stoixeio   
 *				      prodeiktis
*/
	typos_deikti prosorinos; /*       */

	prosorinos = (typos_deikti)malloc(sizeof(typos_komvou));
	if ( prosorinos == NULL )
	{
		fprintf(stderr,"   \n");
		exit(-1);
	}
	else
	{
		prosorinos->dedomena = stoixeio;
		prosorinos->epomenos = prodeiktis->epomenos;
		prodeiktis->epomenos = prosorinos;
	}
}

void chl_diagrafi(typos_deikti *lista, typos_deikti prodeiktis)
{
 /*	
 *	o: 		 prodeiktis        NULL
 *	: 		  prodeiktis  NULL      
 *				 ,          prodeiktis
*/
	typos_deikti prosorinos;

	if (chl_keni(*lista))
		printf("   !\n");
	else /*o   */
	{
		prosorinos = prodeiktis->epomenos;
		prodeiktis->epomenos = prosorinos->epomenos;
		free(prosorinos);
		prosorinos = NULL;
	}
}

void chl_proxorise(typos_deikti *p)
{
 /*	
 *	o: 		  p     
 *	:		  p      
*/
	*p = (*p)->epomenos;
}

void chl_anazitisi(typos_deikti lista,typos_stoixeiou stoixeio,int *vrethike)
{
	typos_deikti trexon;

	trexon = lista;
	chl_proxorise(&trexon);
	*vrethike = 0;
	while ( (!(*vrethike)) && (!chl_keni(trexon)))
	{
		if (chl_periexomeno(trexon) == stoixeio)
			*vrethike = 1;
		else
			chl_proxorise(&trexon);
	}
}

