/*****************************************************
 oo	: ch9_GDijkstra.c
			: .  
				:    Dijkstra
******************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch9_GDijkstra.h"
#include "ch2_Set.h"

/*o */

void Dimiourgia_graphimatos(graphima *G)
{
 /*	
 *	o: 		
 *	: 		    geit_pin   INFINITY
*/
	int i,j;
	for(i=0;i<=G->arkrfon-1;i++)
		for(j=0;j<=G->arkrfon-1;j++)
			(G->geit_pin)[i][j]=INFINITY;
}

void Diavasma_graphimatos(graphima *G)
{
 /*	
 *	o: 		   geit_pin  
 *	: 		   geit_pin  
*/
	korifi i,j;
	int kostos;

	printf("    \n");
	printf(" i,j  kostos\n");
	printf(" -1   \n\n");
	scanf("%d %d %d",&i,&j,&kostos);

	while(i != -1)
	{
		if ( (i<G->arkrfon) && (j<G->arkrfon) && (i>=0) && (j>=0) )
			G->geit_pin[i][j] = kostos;
		else
			printf("\n \n");
		scanf("%d %d %d",&i,&j,&kostos);
	}
}

void Ektyposh_graphimatos(graphima G)
{
 /*	
 *	o: 		      
 *	: 		          
 *				     
*/
	korifi i,j;

	printf("     &d\n",INFINITY);
	printf("     \n\n");
	for (i=0;i<=G.arkrfon-1;i++)
	{
		printf(" %2d ",i);
		for (j=0;j<=G.arkrfon-1;j++)
			printf("%8d",G.geit_pin[i][j]);
		printf("\n");
	}
	printf("\n");
}
void Dijkstra(graphima G)
{
 /*	
 *	o: 		To G     
 *	: 		       0   G
 *				           D
*/
	typos_synolou S; /*   */
	korifi i,j,w;

	int elaxisti_apostasi;
	int apostasi[PLITHOS];
	int monopati[PLITHOS];

	dimiourgia(S);
	eisagogi(0,S);

	/*            0*/
	for(j=1;j<=G.arkrfon-1;j++)
	{
		apostasi[j] = G.geit_pin[0][j];
		if (G.geit_pin[0][j] == INFINITY)
			monopati[j] = 0;
		else
			monopati[j] = 1;
	}

	for(i=1;i<=G.arkrfon-1;i++)
	{
		/*   w   V-S  	apostasi[w]=min*/
		elaxisti_apostasi = INFINITY;
		for(j=1;j<=G.arkrfon-1;j++)
			if ((!melos(j,S))&&(apostasi[j]<elaxisti_apostasi))
			{
				elaxisti_apostasi = apostasi[j];
				w = j;
			}
		/*  w  S*/
		eisagogi(w,S);
		/*      apostasi*/
		for(j=1;j<=G.arkrfon-1;j++)
			if ((!melos(j,S))&&((apostasi[w]+G.geit_pin[w][j])<apostasi[j]))
			{
				apostasi[j] = apostasi[w]+G.geit_pin[w][j];
				monopati[j] = w;
			}
	}
	printf("\n  ");
	printf("\n-  \n");
	for(i=1;i<=G.arkrfon-1;i++)
		printf("%6d %17d %11d\n",i,apostasi[i],monopati[i]);
}

int main(void)
{
	graphima G;
	printf("    :");
	scanf("%d",&(G.arkrfon));
	Dimiourgia_graphimatos(&G);
	Diavasma_graphimatos(&G);
	Ektyposh_graphimatos(G);
	Dijkstra(G);
	return 0;
}







