/****************************************************************************
 oo	: ch9_Garray.c
			: .  
				:      , 
*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch9_Garray.h"

/*o */

void dimiourgia(graphima *G)
{
 /*	
 *	o: 		
 *	: 		o   
*/	
	G->arkrfon=0;
}

int geitoniki(int p, int q, graphima G)
{
 /*	
 *	o: 		         G
 *	: 		      p  q     1
 *				  0.
*/	
	if ( (p<0) || (p>G.arkrfon-1) || (q<0) || (p>G.arkrfon-1) )
	{
		fprintf(stderr," \n");
		exit(-1);
	}
	else 
		return (G.geit_pin[p][q]);

}

void eisagogi_akmis(int p, int q, graphima *G)
{
 /*	
 *	o: 		  p,q        G   
 *				(p,q)       *G
 *	: 		  (p,q)        *g 
 *				,  
*/	
	if ( (p<0) || (p>G->arkrfon-1) || (q<0) || (p>G->arkrfon-1) )
	{
		fprintf(stderr," \n");
		exit(-1);
	}
	else if (geitoniki(p,q,*G)) 
		printf("   \n");
	else
	{
		G->geit_pin[p][q] = 1;
		G->geit_pin[q][p] = 1;
	}
}

int diagrafi_akmis(int p, int q, graphima *G)
{
 /*	
 *	o: 		H (p,q)       *G
 *	: 		  (p,q)        (p,q) 
 *				  *g     1,  0.
*/	
	if ( (p<0) || (p>G->arkrfon-1) || (q<0) || (p>G->arkrfon-1) )
	{
		fprintf(stderr," \n");
		exit(-1);
	}
	else if (!geitoniki(p,q,*G)) 
		return 0;
	else
	{
		G->geit_pin[p][q] = 0;
		G->geit_pin[q][p] = 0;
		return 1;
	}
}

void eisagogi_korifis(int *p, graphima *G)
{
 /*	
 *	o: 		  *G     
 *	: 		   *G   G->arkrfon    	 
 *				 ,  *p         1
*/
	int i;

	if (G->arkrfon == PLITHOS)
	{
		fprintf(stderr,"   \n");
		exit(-1);
	}
	else
	{
		(G->arkrfon)++;
		*p = G->arkrfon -1; /*T */
		for (i=0;i<=*p;i++)
		{
			G->geit_pin[*p][i]= 0; /*N */
			G->geit_pin[i][*p]= 0; /*N */
		}
	}
}

void diagrafi_korifis(int p, graphima *G)
{
 /*	
 *	o: 		  p        *G
 *	: 		   p        *G,
 *				          .
 *				            
 *				0,1,..., G->arkrfon-1
*/
	int i,j;

	if ( (p<0) || (p>G->arkrfon-1) )
	{
		fprintf(stderr," \n");
		exit(-1);
	}
	else
	{
		/*  i+1    */
		for (i=p;i<=G->arkrfon - 2;i++)
			for (j=0;j<=G->arkrfon - 1;j++)
				G->geit_pin[i][j] = G->geit_pin[i+1][j];
		/*  i+1    */
		for (i=p;i<=G->arkrfon - 2;i++)
			for (j=0;j<=G->arkrfon - 2;j++)
				G->geit_pin[j][i] = G->geit_pin[j][i+1];
		G->arkrfon--;
	}
}







