/****************************************************************************
 oo	: ch9_GedgeList.c
			: .  
				:      , 
*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch9_GedgeList.h"

/*o */

int keni_k(kdktis lista)
{
 /*	
 *	o: 		o 
 *	:		 1     , o 0
*/
	return ( lista == NULL );
}

int keni_a(adktis lista)
{
 /*	
 *	o: 		o 
 *	:		 1     , o 0
*/
	return ( lista == NULL );
}

void proxorise_k(kdktis *p)
{
 /*	
 *	o: 		  p     
 *	:		  p      
*/
	*p = (*p)->epomenos;
}

void proxorise_a(adktis *p)
{
 /*	
 *	o: 		  p     
 *	:		  p      
*/
	*p = (*p)->epomenos;
}

void enimerosi(typos_stoixeiou stoixeio, kdktis p)
{
 /*	
 *	o: 		  p    
 *	:		  stoixeio      p
*/
	p->dedomena = stoixeio;
}

typos_stoixeiou anaktisi(kdktis p)
{
 /*	
 *	o: 		  p    
 *	:		          p
*/
	return (p->dedomena);
}

void dimiourgia(graphima *G)
{
 /*	
 *	o: 		
 *	: 		o   
*/	
	*G=NULL;
}

int geitoniki(kdktis p, kdktis q, graphima G)
{
 /*	
 *	o: 		         G
 *	: 		      p  q     1
 *				  0.
*/	
	int telos;		/*         p*/
	adktis trexon;	/*        p*/
	int geit;

	geit=0;
	trexon = p->kefali; /*        p*/
	telos = 0;

	while( (!telos) && (!keni_a(trexon)) )
	{
		if (trexon->akro == q ) /*    q   */
		{
			telos = 1;
			geit = 1;
		}
		else
			proxorise_a(&trexon);
	}
	return geit;
}

void diagrafi_korifis(kdktis p, graphima *G)
{
 /*	
 *	o: 		     *G
 *	: 		     *G      p
*/
	kdktis trexon;
	trexon = *G; /* trexon    */
	while (!keni_k(trexon))
	{
		/*     (p,p) */
		if (p!=trexon) /*  (trexon,p)  */
			diagrafi_komvou(p,&(trexon->kefali));
		proxorise_k(&trexon);	 /*   */
	}
	diagrafi_listas(&(p->kefali));
}

void diagrafi_komvou(kdktis v, adktis *kefali)
{
 /*	
 *	o: 		  v    
 *	: 		          
 *				  *kefali    akro    v
*/
	adktis pros;

	if (!keni_a(*kefali))
	{
		if ((*kefali)->akro==v)/* */
		{
			pros = *kefali;
			proxorise_a(kefali);
			free(pros);
		}
		else /*      */
			diagrafi_komvou(v,&((*kefali)->epomenos));
	}
}

void diagrafi_listas(adktis *kefali)
{
 /*	
 *	o: 		  kefali   
 *	: 		         
 *				  *kefali
*/
	if (!keni_a(*kefali))
	{
		diagrafi_listas(&((*kefali)->epomenos));
		free(*kefali);
		*kefali = NULL;
	}
}

void eisagogi_korifis(typos_stoixeiou stoixeio, graphima *G)
{
 /*	
 *	o: 		     *G
 *	:		           stoixeio
*/
	kdktis p;

	p = (kdktis)malloc(sizeof(struct korifi));
	p->dedomena = stoixeio;
	/*         G*/
	p->epomenos = *G;
	p->kefali = NULL;	/*    p  */
	*G = p; /*    p          *G */
}

void eisagogi_akmis(kdktis p, kdktis q, graphima *G)
{
 /*	
 *	o: 		  p,q       G   
 *				(p,q)       *G
 *	: 		  (p,q)        *g 
 *				,  
*/	  
	adktis pros;

	if (!geitoniki(p,q,*G))
	{
		/*       p*/
		pros = p->kefali;
		/*     */
		p->kefali = (adktis)malloc(sizeof(struct akmi));
		/*      p*/
		p->kefali->akro = q;
		/*        q*/
		p->kefali->epomenos = pros;
		/*     q*/
		pros = q->kefali;
		q->kefali = (adktis)malloc(sizeof(struct akmi));
		q->kefali->akro = p;
		q->kefali->epomenos = pros;
	}
}

void diagrafi_akmis(kdktis p, kdktis q, graphima *G)
{
 /*	
 *	o: 		     *G.  p,q  
 *				    *G.
 *	: 		         p,q
 *				    *G
*/	  
	if (geitoniki(p,q,*G))
	{
		/*      p*/
		diagrafi_komvou(q,&(p->kefali));
		/*      q*/
		diagrafi_komvou(p,&(q->kefali));
	}
}









