/************************************************************************
 oo垩	: ch8_BSTpointer.c
☪			: .  
				: 垩  填 ,  ⤫ 㫞
*************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch8_BSTpointer.h"

void dimiourgia_dentro(typos_deikti *riza)
{
 /*	
 *	o: 		
 *	: 		o    ⤫
*/	
	*riza = NULL;
}

int	keno_dentro(typos_deikti riza)
{
 /*	
 *	o: 		o   ⤫
 *	:		⭜ 1   ⤫ 夘 , o 0
*/
	return ( riza == NULL );
}

typos_deikti aristero_paidi(typos_deikti p)
{
 /*	
 *	o: 		 p 室 ⤘ 棙  ⤘  ⤫
 *	:		⭜     室  p
*/
	if (!keno_dentro(p))
		return (p->apaidi);
	else
		return NULL;
}

typos_deikti dexi_paidi(typos_deikti p)
{
 /*	
 *	o: 		 p 室 ⤘ 棙  ⤘  ⤫
 *	:		⭜     室  p
*/
	if (!keno_dentro(p))
		return (p->dpaidi);
	else
		return NULL;
}

void episkepsi(typos_deikti riza)
{
	riza->dedomena;
}

void endodiataksi(typos_deikti riza)
{
 /*	
 *	o: 		o   ⤫
 *	:		⮜  ⤞  ⤘  . 
 *				ᨫ episkepsi ᝜   dedomena  棙
*/
	if (!keno_dentro(riza))
	{
		/*婡   ⤛*/
		endodiataksi(riza->apaidi);

		/*婡  坘*/
		episkepsi(riza);

		/*婡   ⤛*/
		endodiataksi(riza->dpaidi);
	}
}

void prodiataksi(typos_deikti riza)
{
 /*	
 *	o: 		o   ⤫
 *	:		⮜  ⤞  ⤘  . 
 *				ᨫ episkepsi ᝜   dedomena  棙
*/
	if (!keno_dentro(riza))
	{
		episkepsi(riza);
		endodiataksi(riza->apaidi);
		endodiataksi(riza->dpaidi);
	}
}

void metadiataksi(typos_deikti riza)
{
 /*	
 *	o: 		o   ⤫
 *	:		⮜  ⤞  ⤘  . 
 *				ᨫ episkepsi ᝜   dedomena  棙
*/
	if (!keno_dentro(riza))
	{
		endodiataksi(riza->apaidi);
		endodiataksi(riza->dpaidi);
		episkepsi(riza);
	}
}

void eisagogi_dentro1(typos_deikti *riza, typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		o   ⤫ 㫞
 *	:		᚜ ⤘  棙   橦  ᨮ
*/
	if (keno_dentro(*riza)) /*   */
	{
		*riza = (typos_deikti)malloc(sizeof(struct typos_komvou));
		(*riza)->dedomena = stoixeio;
		(*riza)->apaidi = NULL;
		(*riza)->dpaidi = NULL;
	}
	else if (stoixeio < (*riza)->dedomena)	/*   曜*/
		eisagogi_dentro1(&((*riza)->apaidi),stoixeio);
	else if (stoixeio > (*riza)->dedomena)	/*   曜*/
		eisagogi_dentro1(&((*riza)->dpaidi),stoixeio);
	else  /* 棙 夘 㛞  ⤫*/
		printf(" 棙 夘 㛞  ");
}

void eisagogi_dentro2(typos_deikti *riza, typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		o   ⤫ 㫞
 *	:		᚜ ⤘  棙   橦  ᨮ
*/
	typos_deikti prosorinos,pateras;
	int vrethike;
	pateras = anazitisi_patera(*riza,stoixeio,&vrethike);
	if (vrethike)
		printf(" 棙 夘 㛞  ");
	else
	{
		prosorinos = (typos_deikti)malloc(sizeof(struct typos_komvou));
		prosorinos->dedomena = stoixeio;
		prosorinos->apaidi = NULL;
		prosorinos->dpaidi = NULL;
		if (pateras == NULL) /* */
			*riza = prosorinos;
		else if ( stoixeio < pateras->dedomena )	
			pateras->apaidi = prosorinos;
		else
			pateras->dpaidi = prosorinos;
	}
}
void diagrafi_dentrou(typos_deikti *riza, typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		o   ⤫ 㫞
 *	:		⮜   棙  棜 stoixeio
*/
	typos_deikti x;			/*  棙  棜 stoixeio */
	typos_deikti pateras;	/*   x   xepomenos */
	typos_deikti xepomenos;	/*o ⤦ 棜  x*/
	typos_deikti ypodentro;	/*室  ⤫  x*/
	int vrethike;

	pateras = anazitisi_patera2(*riza,stoixeio,&x,&vrethike);
	if (!vrethike)
		printf(" 棙  ᨮ  ");
	else
	{
		/* 棙 ⮜ 2 */
		if ((x->apaidi !=NULL)&&(x->dpaidi !=NULL))
		{
			/*  ⤦ 棜   ⨘ */
			xepomenos = x->dpaidi;
			pateras = x;
			while (xepomenos->apaidi !=NULL)
			{
				/*᫠  ⤫*/
				pateras = xepomenos;
				xepomenos = xepomenos->apaidi;
			}
			/*    xepomenos  x    
			  x ⫩ 驫  室  xepomeno  桜  */
			x->dedomena = xepomenos->dedomena;
			x = xepomenos;
		}
		/*騞  驜   棙 ⮜ 0  1 */
		ypodentro = x->dpaidi;
		if (ypodentro == NULL)
			ypodentro = x->apaidi;
		if (pateras ==NULL) /*᭜  坘*/
			*riza = ypodentro;
		else if (pateras->apaidi == x) /*    ⨘*/
			pateras->apaidi = ypodentro;
		else
			pateras->dpaidi = ypodentro;
		free(x);
	}
}

void diagrafi_komvou(typos_deikti *riza, typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		o   ⤫ 㫞
 *	:		⮜   棙  棜 stoixeio
*/
	typos_deikti prosorinos,xepomenos;

	if (!keno_dentro(*riza))
	{
		if (stoixeio==(*riza)->dedomena)
		{
			if (keno_dentro((*riza)->apaidi))/* 坘  ⮜  */
			{
				prosorinos = *riza;
				*riza = (*riza)->dpaidi;
				free(prosorinos);
			}
			else if (keno_dentro((*riza)->dpaidi))/* 坘  ⮜  */
			{
				prosorinos = *riza;
				*riza = (*riza)->apaidi;
				free(prosorinos);
			}
			else /** 坘 ⮜  */
			{
				/*稜  ⤦ 棜*/
				xepomenos = (*riza)->dpaidi;
				while (xepomenos->apaidi !=NULL)
					xepomenos = xepomenos->apaidi;
				/*    xepomenos  riza*/
				(*riza)->dedomena = xepomenos->dedomena;
				diagrafi_komvou(&((*riza)->dpaidi),(*riza)->dedomena);
			}
		}
		else if (stoixeio < (*riza)->dedomena)
			diagrafi_komvou(&((*riza)->apaidi),stoixeio);
		else	/*㫞   曜*/
			diagrafi_komvou(&((*riza)->dpaidi),stoixeio);
	}
}

typos_deikti anazitisi_dentrou1(typos_deikti riza, typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		o   ⤫ 㫞
 *	:		⭜ ⤘ 填  棙  ⮜  stoixeio  NULL
*/
	if (keno_dentro(riza)) /* */
		return NULL;
	if (riza->dedomena == stoixeio)
		return riza;
	if (stoixeio < riza->dedomena)	/*㫞   曜*/
		return anazitisi_dentrou1(riza->apaidi,stoixeio);
	else	/*㫞   曜*/
		return anazitisi_dentrou1(riza->dpaidi,stoixeio);
}

typos_deikti anazitisi_dentrou2(typos_deikti prosorinos, typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		o   ⤫ 㫞
 *	:		⭜ ⤘ 填  棙  ⮜  stoixeio  NULL
*/
	while(!keno_dentro(prosorinos)) 
	{
		if (prosorinos->dedomena == stoixeio)
			return prosorinos;
		if ( stoixeio < prosorinos->dedomena )	
			prosorinos = prosorinos->apaidi;
		else
			prosorinos = prosorinos->dpaidi;
	}
	return NULL; /* ⟞ 棙   ⤫ 夘 */
}

typos_deikti anazitisi_patera(typos_deikti riza, typos_stoixeiou stoixeio,int *vrethike)
{
 /*	
 *	o: 		o   ⤫ 㫞
 *	:		⭜ ⤘ 填   棙  㟞   㫞
 *				  ⤫ 夘   ᨮ 棙  ⤦ stoixeio  NULL
*/
	typos_deikti prosorinos,pateras;
	prosorinos = riza;
	pateras = NULL;
	*vrethike = 1;

	while(!(*vrethike)&&(prosorinos!=NULL)) 
	{
		pateras = prosorinos;
		if ( stoixeio < prosorinos->dedomena )	
			prosorinos = prosorinos->apaidi;
		else if ( stoixeio > prosorinos->dedomena )
			prosorinos = prosorinos->dpaidi;
		else /* 棙 夘 㛞  ⤫*/
		{
			*vrethike = 1;
			pateras = NULL;
		}
	}
	return pateras;
}

typos_deikti anazitisi_patera2(typos_deikti riza, typos_stoixeiou stoixeio,typos_deikti *prosorinos
							   ,int *vrethike)
{
 /*	
 *	o: 		o   ⤫ 㫞
 *	:		⭜ ⤘ 填   棙  㟞   㫞
 *				  ⤫ 夘   ᨮ 棙  ⤦ stoixeio  NULL
*/
	typos_deikti pateras;
	*prosorinos = riza;
	pateras = NULL;
	*vrethike = 1;

	while(!(*vrethike)&&((*prosorinos)!=NULL)) 
	{
		pateras = (*prosorinos);
		if ( stoixeio < (*prosorinos)->dedomena )	
			*prosorinos = (*prosorinos)->apaidi;
		else if ( stoixeio > (*prosorinos)->dedomena )
			*prosorinos = (*prosorinos)->dpaidi;
		else /* 棙 夘 㛞  ⤫*/
		{
			*vrethike = 1;
			pateras = NULL;
		}
	}
	return pateras;
}
