/***********************************************************************************
 oo	: ch8_Tarray.c
			: .  
				:      ,  
************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch8_Tarray.h"

void arxiki_katastasi(void)
{
 /*	
 *	o: 		
 *	: 		o      
*/	
	int i;
	/*    */
	for (i=0;i<PLITHOS-1;i++)
		komvos[i].epomenos=i+1;
	/*   */
	komvos[PLITHOS-1].epomenos=null;
	kenos=0;
}

void pare_komvo(typos_deikti *p)
{
 /*	
 *	o: 		   arxiki_katastasi
 *	: 		O  p     .   
 *				          .
*/	
	*p = kenos;
	if (kenos!=null)
		kenos = komvos[kenos].epomenos;
	else
		printf("   ");
}

void apodesmeysi(typos_deikti p)
{
 /*	
 *	o: 		   arxiki_katastasi
 *	: 		     o p       
*/	
	komvos[p].epomenos = kenos;
	kenos = p;
}

void dimiourgia(typos_deikti *lista)
{
 /*	
 *	o: 		
 *	: 		o   
*/	
	*lista = null;
}

int keni(typos_deikti lista)
{
 /*	
 *	o: 		o 
 *	:		 1     , o 0
*/
	return ( lista == null );
}

void proxorise(typos_deikti *p)
{
 /*	
 *	o: 		  p     
 *	:		  p      
*/
	*p = komvos[*p].epomenos;
}

typos_stoixeiou periexomeno(typos_deikti p)
{
 /*	
 *	o: 		  p     
 *	:		        p
*/
	return (komvos[p].dedomena);
}

void eisagogi_meta(typos_deikti prodeiktis,typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		o 
 *	: 		     stoixeio   
 *				      prodeiktis
*/
	typos_deikti prosorinos; /*       */

	pare_komvo(&prosorinos);
	komvos[prosorinos].dedomena=stoixeio;
	komvos[prosorinos].epomenos=komvos[prodeiktis].epomenos;
	komvos[prodeiktis].epomenos=prosorinos;
}

void eisagogi_arxi(typos_deikti *lista,typos_stoixeiou stoixeio)
{
 /*	
 *	o: 		O  p     
 *	: 		     stoixeio   
 *				      p,  p       
*/
	typos_deikti prosorinos;

	pare_komvo(&prosorinos);
	komvos[prosorinos].dedomena=stoixeio;
	komvos[prosorinos].epomenos=*lista;
	*lista=prosorinos;
}

void eisagogi(typos_deikti *lista,typos_stoixeiou stoixeio,typos_deikti prodeiktis)
{
 /*	
 *	o: 		o 
 *	: 		  prodeiktis  null(-1)      
 *				stoixeio          
 *				     prodeiktis
*/
	if (keni(prodeiktis)) /*    */
		eisagogi_arxi(lista,stoixeio);
	else
		eisagogi_meta(prodeiktis,stoixeio);
}

void diagrafi_komvou(typos_deikti *lista, typos_deikti prodeiktis)
{
 /*	
 *	o: 		 prodeiktis        null
 *	: 		  prodeiktis  null(-1)      
 *				 ,          prodeiktis
*/
	if (keni(*lista))
		printf("   !\n");
	else
	{
		if (keni(prodeiktis))
			diagrafi(lista);
		else
			diagrafi(&komvos[prodeiktis].epomenos);
	}
}

void diagrafi(typos_deikti *p)
{
 /*	
 *	o: 		 p     
 *	: 		      p.  p     
*/
	typos_deikti prosorinos;	/*     */
	prosorinos = *p;
	*p = komvos[prosorinos].epomenos;
	apodesmeysi(prosorinos);
}

void anazitisi1(typos_deikti lista,typos_stoixeiou stoixeio,
				typos_deikti *prodeiktis, int *vrethike)
{
 /*	
 *	o: 		o 
 *	: 		   lista       
 *				     stoixeio (vrethike =1)    
 *				     (vrethike =0).  prodeiktis  
 *				       stoixeio     
 *				      stoixeio
*/
	typos_deikti trexon;

	trexon = lista;
	*prodeiktis = null;
	*vrethike = 0;
	while ( (!(*vrethike)) && (!keni(trexon)))
	{
		if (periexomeno(trexon) == stoixeio)
			*vrethike =1;
		else
		{
			*prodeiktis = trexon;
			proxorise(&trexon);
		}
	}
}

void anazitisi2(typos_deikti lista,typos_stoixeiou stoixeio,
				typos_deikti *prodeiktis, int *vrethike)
{
 /*	
 *	o: 		        
 *	: 		   lista       
 *				     stoixeio (vrethike =1)    
 *				     (vrethike =0).  prodeiktis  
 *				       stoixeio     
 *				      stoixeio
*/
	typos_deikti trexon;
	int anazitisi;

	trexon = lista;
	*prodeiktis = null;
	*vrethike = 0;
	anazitisi=0;
	while ( (!(anazitisi)) && (!keni(trexon)))
	{
		if (periexomeno(trexon) >= stoixeio)
		{
			anazitisi = 1;
			*vrethike = (periexomeno(trexon) == stoixeio);
		}
		else
		{
			*prodeiktis = trexon;
			proxorise(&trexon);
		}
	}
}




