/***************************************************************************************
 oo	: ch8_Tpointer.c
			: .  
				:      ,  
****************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ch8_Tpointer.h"
#include "ch4_Stack.h"

void dimiourgia_dentro(typos_deikti *riza)
{
 /*	
 *	o: 		
 *	: 		o    
*/	
	*riza = NULL;
}

int	keno_dentro(typos_deikti riza)
{
 /*	
 *	o: 		o   
 *	:		 1     , o 0
*/
	return ( riza == NULL );
}

typos_deikti aristero_paidi(typos_deikti p)
{
 /*	
 *	o: 		 p       
 *	:		       p
*/
	if (!keno_dentro(p))
		return (p->apaidi);
	else
		return NULL;
}

typos_deikti dexi_paidi(typos_deikti p)
{
 /*	
 *	o: 		 p       
 *	:		       p
*/
	if (!keno_dentro(p))
		return (p->dpaidi);
	else
		return NULL;
}

void episkepsi(typos_deikti riza)
{
	riza->dedomena;
}

void endodiataksi(typos_deikti riza)
{
 /*	
 *	o: 		o   
 *	:		      . 
 *				 episkepsi    dedomena  
*/
	if (!keno_dentro(riza))
	{
		/*   */
		endodiataksi(riza->apaidi);

		/*  */
		episkepsi(riza);

		/*   */
		endodiataksi(riza->dpaidi);
	}
}

void prodiataksi(typos_deikti riza)
{
 /*	
 *	o: 		o   
 *	:		      . 
 *				 episkepsi    dedomena  
*/
	if (!keno_dentro(riza))
	{
		episkepsi(riza);
		endodiataksi(riza->apaidi);
		endodiataksi(riza->dpaidi);
	}
}

void metadiataksi(typos_deikti riza)
{
 /*	
 *	o: 		o   
 *	:		      . 
 *				 episkepsi    dedomena  
*/
	if (!keno_dentro(riza))
	{
		endodiataksi(riza->apaidi);
		endodiataksi(riza->dpaidi);
		episkepsi(riza);
	}
}

void endodiataksi2(typos_deikti riza)
{
 /*	
 *	o: 		o   
 *	:		      .
*/
	if (!keno_dentro(riza))
	{
		int sfalma;
		typos_stoivas stoiva;
		typos_deikti trexon;
		dimiourgia(&stoiva);
		trexon = riza;
		do
		{
		/*     */
			while (!keno_dentro(trexon))
			{
				othisi(&stoiva,trexon,&sfalma);
				trexon = aristero_paidi(trexon);
			}
			/*     */
			if (!keni(stoiva)) /*    */
			{
				exagogi(&stoiva,&trexon,&sfalma);
				/*  */
				episkepsi(trexon);
				/*   */
				trexon = dexi_paidi(trexon);
			}
		}while ((!keni(stoiva))||(!keno_dentro(trexon)));
	}
}
