/************************************************************************
 oo	: ch9_GSpanTree.c
			: .  
				:      
*************************************************************************/
#include "ch6_Qarray.h"
#include "ch9_GedgeList.h"
#include "ch9_GSpanTree.h"

typos_ouras oura;

/*o */

void vathos_spantree(graphima G)
{
 /*	
 *	o: 		o   G
 *	: 		      
*/	
	kdktis p; /*    */
	adktis a; /*    */
	p = G;
	/*        .    
	 G              */

	while(!keni_k(p))
	{
		/*     */
		p->episkeftike = 0;
		a = p->kefali;
		/*            
		      */
		while(!keni_a(a))
		{
			a->simadi = 0;
			proxorise_a(&a);
		}
		proxorise_k(&p);
	}
	
	p = G; /*  */
	vathos_dimiourgia(p);
}

void vathos_dimiourgia(kdktis p)
{
	adktis trexon;
	kdktis q;

	p->episkeftike = 1;
	trexon = p->kefali;

	while(!keni_a(trexon))
	{
		q = trexon->akro;
		if (!q->episkeftike)
		{
			/*     */
			trexon->simadi = 1;
			vathos_dimiourgia(q);
		}
		proxorise_a(&trexon);
	}
}

void platos(graphima G)
{
 /*	
 *	o: 		o   G
 *	: 		      
*/	
	kdktis n,m;
	adktis trexon;
	n = G;
	while(!keni_k(n))
	{
		n->episkeftike = 0;
		trexon = n->kefali;
		while(!keni_a(trexon))
		{
			trexon->simadi = 0;
			proxorise_a(&trexon);
		}
		proxorise_k(&n);
	}
	dimiourgia_q(&oura);
	/*        */
	n = G; 

	prosthesi(&oura,n);
	n->episkeftike = 1;

	while (!keni(oura))
	{
		apomakrynsh(&oura,&n);
		/*   */
		trexon = n->kefali;
		while(!keni_a(trexon))
		{
			m = trexon->akro;
			if (!m->episkeftike)
			{
				prosthesi(&oura,m);
				m->episkeftike = 1;
				trexon->simadi = 1; 
			}
			proxorise_a(&trexon);
		}
	}
}
